package esercizio1;

import java.util.ArrayList;
import java.util.List;

public class CarrelloLibreria 
{
	private List<Libro> libri;

	public CarrelloLibreria() {
		this(new ArrayList<Libro>());
	}

	public CarrelloLibreria(List<Libro> listaLibri) {
		this.libri = listaLibri;
	}
	
	public boolean aggiungiLibro(Libro l)
	{
		boolean aggiunto = false, trovato = false;
		for(int i = 0; i < libri.size() && !trovato; i++) {
			if(libri.get(i).getISBN().equalsIgnoreCase(l.getISBN())) {
				trovato = true;
				if(l.getCosto() < libri.get(i).getCosto()) {
					libri.set(i, l); // in alternativa: libri.remove(i); libri.add(l);
					aggiunto = true;
				}
			}
		}
		if(!trovato) {
			libri.add(l);
			aggiunto = true;
		}
		return aggiunto;
		
	}	


	public double getConto()
	{
		double sum = 0;
		for(int i = 0; i < libri.size(); i++) {
			sum += libri.get(i).getCosto();
		}	
		return sum;	
	}
}
