package esercizio2;

import java.util.*;

public class GestoreTelefonico{

	private static final int MAX_TARIFFE=15;
	
	private Tariffa[] tariffe;
    private int numTariffe;
	private List<Telefonata> telefonate;
	private List<TariffaUtente> tariffeUtenti;
	
	public GestoreTelefonico(){
		this(new Tariffa[MAX_TARIFFE], 0, new ArrayList<Telefonata>(), new ArrayList<TariffaUtente>());
	}
	
	public GestoreTelefonico(Tariffa[] tariffe, int numTariffe, List<Telefonata> telefonate, List<TariffaUtente> tariffeUtenti) {
		this.tariffe = tariffe;
		this.numTariffe = numTariffe;
		this.telefonate = telefonate;
		this.tariffeUtenti = tariffeUtenti;
	}
	
	
	public Tariffa cercaTariffa(String nome){
		boolean trovata=false;
		Tariffa t = null;
		for(int i=0;i<numTariffe && !trovata;i++){
			if(tariffe[i].getNome().equals(nome)){
				trovata=true;
				t=tariffe[i];
			}
		}
		return t;
	}
	
    public void registraUtente(String numTelefono, String nomeTariffa){
		TariffaUtente tu= new TariffaUtente(numTelefono, nomeTariffa);
		boolean trovato = false;
		for(int i=0; i<tariffeUtenti.size() && !trovato; i++)
			if(tariffeUtenti.get(i).getNumTelefono().equals(numTelefono)) {
				trovato = true;
				tariffeUtenti.set(i,tu);
			}
		if(!trovato)
			tariffeUtenti.add(tu);
	}
	
	public List<Telefonata> telefonateMensili(String numTelefono, String mese){
		List<Telefonata> telefonateMensili = new ArrayList<Telefonata>();
		for(int i = 0; i < telefonate.size(); i++) {
			if(telefonate.get(i).getSorgente().equals(numTelefono)) {
				String data = telefonate.get(i).getData();
				if(data.substring(data.indexOf("/")+1).equals(mese)) 
					telefonateMensili.add(telefonate.get(i));
			}
		}
		return telefonateMensili;
	}

	public Tariffa tariffaPerUtente(String telefono) {
		boolean trovato = false;
		Tariffa tariffa = null;
		for(int i = 0; i < tariffeUtenti.size() && !trovato; i++) {
			if(tariffeUtenti.get(i).getNumTelefono().equals(telefono)) {
				trovato = true;
				tariffa = cercaTariffa(tariffeUtenti.get(i).getNomeTariffa());
			}
		}
		return tariffa;
	}


	public double calcolaCostoMensile(String numTelefono, String mese){
		double importo=0;
		Tariffa t = tariffaPerUtente(numTelefono);
		if(t instanceof Flat){
			Flat f = (Flat)t;
			importo = f.getCanoneMensile();
		}
		else{
			Minuti m = (Minuti)t;
			List<Telefonata> telefonate = telefonateMensili(numTelefono, mese);
			for(int i=0;i<telefonate.size();i++){
				Telefonata tel = telefonate.get(i);
				importo += tel.getDurata()*m.getCostoAlMinuto()+ m.getScattoAllaRisposta();
			}
		}
		return importo;
	}

	
	/*
	 * metodi getter e setter necessari solo al funzionamento del programma principale
	 */
	
	public Tariffa[] getTariffe() {
		return tariffe;
	}

	public void setTariffe(Tariffa[] tariffe) {
		this.tariffe = tariffe;
	}
	
	public int getNumTariffe() {
		return numTariffe;
	}
	
	public void setNumTariffe(int numTariffe) {
		this.numTariffe = numTariffe;
	}
	public List<Telefonata> getTelefonate() {
		return telefonate;
	}
	
}
